/* A Bison parser, made by GNU Bison 2.6.1.  */

/* Bison implementation for Yacc-like parsers in C
   
      Copyright (C) 1984, 1989-1990, 2000-2012 Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.6.1"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         _mp_equation_parse
#define yylex           _mp_equation_lex
#define yyerror         _mp_equation_error
#define yylval          _mp_equation_lval
#define yychar          _mp_equation_char
#define yydebug         _mp_equation_debug
#define yynerrs         _mp_equation_nerrs
#define yylloc          _mp_equation_lloc

/* Copy the first part of user declarations.  */
/* Line 336 of yacc.c  */
#line 1 "./mp-equation-parser.y"

/*  Copyright (c) 2004-2008 Sami Pietila
 *  Copyright (c) 2008-2009 Robert Ancell
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2, or (at your option)
 *  any later version.
 *
 *  This program is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 *  General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
 *  02110-1301, USA.
 */

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <errno.h>
#include <assert.h>

#include "mp-equation-private.h"
#include "mp-equation-parser.h"
#include "mp-equation-lexer.h"

// fixme support x log x
// treat exp NAME exp as a function always and pass both arguments, i.e.
// can do mod using both and all others use $1 * NAME($3)

static void set_error(yyscan_t yyscanner, int error, const char *token)
{
    _mp_equation_get_extra(yyscanner)->error = error;
    if (token)
        _mp_equation_get_extra(yyscanner)->error_token = strdup(token);
}

static void set_result(yyscan_t yyscanner, const MPNumber *x)
{
    mp_set_from_mp(x, &(_mp_equation_get_extra(yyscanner))->ret);
}

static char *
utf8_next_char (const char *c)
{
    c++;
    while ((*c & 0xC0) == 0x80)
        c++;
    return (char *)c;
}

static int get_variable(yyscan_t yyscanner, const char *name, int power, MPNumber *z)
{
    int result = 0;

    /* If defined, then get the variable */
    if (_mp_equation_get_extra(yyscanner)->get_variable(_mp_equation_get_extra(yyscanner), name, z)) {
        mp_xpowy_integer(z, power, z);
        return 1;
    }

    /* If has more than one character then assume a multiplication of variables */
    if (utf8_next_char(name)[0] != '\0') {
        const char *c, *next;
        char *buffer = malloc(sizeof(char) * strlen(name));
        MPNumber value;

        result = 1;
        mp_set_from_integer(1, &value);
        for (c = name; *c != '\0'; c = next) {
            MPNumber t;

            next = utf8_next_char(c);
            snprintf(buffer, next - c + 1, "%s", c);

            if (!_mp_equation_get_extra(yyscanner)->get_variable(_mp_equation_get_extra(yyscanner), buffer, &t)) {
                result = 0;
                break;
            }

            /* If last term do power */
            if (*next == '\0')
                mp_xpowy_integer(&t, power, &t);

            mp_multiply(&value, &t, &value);
        }

        free(buffer);
        if (result)
            mp_set_from_mp(&value, z);
    }

    if (!result)
        set_error(yyscanner, PARSER_ERR_UNKNOWN_VARIABLE, name);

    return result;
}

static void set_variable(yyscan_t yyscanner, const char *name, MPNumber *x)
{
    _mp_equation_get_extra(yyscanner)->set_variable(_mp_equation_get_extra(yyscanner), name, x);
}

static int get_function(yyscan_t yyscanner, const char *name, const MPNumber *x, MPNumber *z)
{
    if (!_mp_equation_get_extra(yyscanner)->get_function(_mp_equation_get_extra(yyscanner), name, x, z)) {
        set_error(yyscanner, PARSER_ERR_UNKNOWN_FUNCTION, name);
        return 0;
    }
    return 1;
}

static int get_inverse_function(yyscan_t yyscanner, const char *name, const MPNumber *x, MPNumber *z)
{
    char *inv_name;
    int result;

    inv_name = malloc(sizeof(char) * (strlen(name) + strlen("⁻¹") + 1));
    strcpy(inv_name, name);
    strcat(inv_name, "⁻¹");
    result = get_function(yyscanner, inv_name, x, z);
    free(inv_name);

    return result;
}

static void do_not(yyscan_t yyscanner, const MPNumber *x, MPNumber *z)
{
    if (!mp_is_overflow(x, _mp_equation_get_extra(yyscanner)->options->wordlen)) {
        set_error(yyscanner, PARSER_ERR_OVERFLOW, NULL);
    }
    mp_not(x, _mp_equation_get_extra(yyscanner)->options->wordlen, z);
}

static char *make_unit(const char *name, int power)
{
    char *name2;

    // FIXME: Hacky
    if (power == 2) {
        name2 = malloc(sizeof(char) * (strlen(name) + strlen("²") + 1));
        sprintf(name2, "%s²", name);
    }
    else if (power == 3) {
        name2 = malloc(sizeof(char) * (strlen(name) + strlen("³") + 1));
        sprintf(name2, "%s³", name);
    }
    else {
        name2 = malloc(sizeof(char) * (strlen(name) + strlen("?") + 1));
        sprintf(name2, "%s?", name);
    }

    return name2;
}

static void do_conversion(yyscan_t yyscanner, const MPNumber *x, const char *x_units, const char *z_units, MPNumber *z)
{
    if (!_mp_equation_get_extra(yyscanner)->convert(_mp_equation_get_extra(yyscanner), x, x_units, z_units, z))
        set_error(yyscanner, PARSER_ERR_UNKNOWN_CONVERSION, NULL);
}


/* Line 336 of yacc.c  */
#line 243 "mp-equation-parser.c"

# ifndef YY_NULL
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULL nullptr
#  else
#   define YY_NULL 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "mp-equation-parser.h".  */
#ifndef _MP_EQUATION_MP_EQUATION_PARSER_H
# define _MP_EQUATION_MP_EQUATION_PARSER_H
/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int _mp_equation_debug;
#endif

/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     tNUMBER = 258,
     tRCEILING = 259,
     tLCEILING = 260,
     tRFLOOR = 261,
     tLFLOOR = 262,
     UNARY_PLUS = 263,
     tSUBTRACT = 264,
     tADD = 265,
     tXNOR = 266,
     tXOR = 267,
     tOR = 268,
     tAND = 269,
     tRSHIFT = 270,
     tLSHIFT = 271,
     MULTIPLICATION = 272,
     tMOD = 273,
     tDIVIDE = 274,
     tMULTIPLY = 275,
     tNOT = 276,
     tROOT4 = 277,
     tROOT3 = 278,
     tROOT = 279,
     tFUNCTION = 280,
     tVARIABLE = 281,
     tNSUPNUM = 282,
     tSUPNUM = 283,
     tSUBNUM = 284,
     BOOLEAN_OPERATOR = 285,
     PERCENTAGE = 286,
     UNARY_MINUS = 287,
     tIN = 288
   };
#endif
/* Tokens.  */
#define tNUMBER 258
#define tRCEILING 259
#define tLCEILING 260
#define tRFLOOR 261
#define tLFLOOR 262
#define UNARY_PLUS 263
#define tSUBTRACT 264
#define tADD 265
#define tXNOR 266
#define tXOR 267
#define tOR 268
#define tAND 269
#define tRSHIFT 270
#define tLSHIFT 271
#define MULTIPLICATION 272
#define tMOD 273
#define tDIVIDE 274
#define tMULTIPLY 275
#define tNOT 276
#define tROOT4 277
#define tROOT3 278
#define tROOT 279
#define tFUNCTION 280
#define tVARIABLE 281
#define tNSUPNUM 282
#define tSUPNUM 283
#define tSUBNUM 284
#define BOOLEAN_OPERATOR 285
#define PERCENTAGE 286
#define UNARY_MINUS 287
#define tIN 288



#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{
/* Line 350 of yacc.c  */
#line 174 "./mp-equation-parser.y"

  MPNumber int_t;
  int integer;
  char *name;


/* Line 350 of yacc.c  */
#line 359 "mp-equation-parser.c"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif

#if ! defined YYLTYPE && ! defined YYLTYPE_IS_DECLARED
typedef struct YYLTYPE
{
  int first_line;
  int first_column;
  int last_line;
  int last_column;
} YYLTYPE;
# define yyltype YYLTYPE /* obsolescent; will be withdrawn */
# define YYLTYPE_IS_DECLARED 1
# define YYLTYPE_IS_TRIVIAL 1
#endif


#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int _mp_equation_parse (void *YYPARSE_PARAM);
#else
int _mp_equation_parse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int _mp_equation_parse (yyscan_t yyscanner);
#else
int _mp_equation_parse ();
#endif
#endif /* ! YYPARSE_PARAM */

#endif /* !_MP_EQUATION_MP_EQUATION_PARSER_H  */

/* Copy the second part of user declarations.  */

/* Line 353 of yacc.c  */
#line 399 "mp-equation-parser.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
	     && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE) + sizeof (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (YYID (0))
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  45
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   548

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  45
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  6
/* YYNRULES -- Number of rules.  */
#define YYNRULES  50
/* YYNRULES -- Number of states.  */
#define YYNSTATES  99

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   288

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    34,     2,     2,     2,    44,     2,     2,
      38,    39,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    37,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    40,     2,    41,    33,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    42,    35,    43,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    36
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint8 yyprhs[] =
{
       0,     0,     3,     5,     8,    12,    17,    21,    23,    26,
      30,    35,    39,    43,    47,    51,    55,    59,    62,    65,
      68,    70,    73,    76,    79,    83,    87,    91,    96,   101,
     105,   109,   112,   115,   119,   123,   127,   129,   133,   137,
     139,   142,   146,   150,   154,   158,   161,   164,   167,   169,
     172
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int8 yyrhs[] =
{
      46,     0,    -1,    48,    -1,    48,    37,    -1,    26,    37,
      48,    -1,     3,    47,    36,    47,    -1,    47,    36,    47,
      -1,    26,    -1,    26,    28,    -1,    38,    48,    39,    -1,
      48,    38,    48,    39,    -1,     7,    48,     6,    -1,     5,
      48,     4,    -1,    40,    48,    41,    -1,    42,    48,    43,
      -1,    35,    48,    35,    -1,    48,    33,    48,    -1,    48,
      28,    -1,    48,    27,    -1,    48,    34,    -1,    49,    -1,
       3,    49,    -1,     9,    48,    -1,    10,     3,    -1,    48,
      19,    48,    -1,    48,    18,    48,    -1,    48,    20,    48,
      -1,    48,    10,    48,    44,    -1,    48,     9,    48,    44,
      -1,    48,    10,    48,    -1,    48,     9,    48,    -1,    48,
      44,    -1,    21,    48,    -1,    48,    14,    48,    -1,    48,
      13,    48,    -1,    48,    12,    48,    -1,     3,    -1,    48,
      16,    48,    -1,    48,    15,    48,    -1,    50,    -1,    25,
      48,    -1,    25,    28,    48,    -1,    25,    27,    48,    -1,
      26,    28,    48,    -1,    29,    24,    48,    -1,    24,    48,
      -1,    23,    48,    -1,    22,    48,    -1,    26,    -1,    26,
      28,    -1,    50,    50,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   204,   204,   205,   206,   207,   208,   212,   213,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   264,   265,
     266
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "tNUMBER", "tRCEILING", "tLCEILING",
  "tRFLOOR", "tLFLOOR", "UNARY_PLUS", "tSUBTRACT", "tADD", "tXNOR", "tXOR",
  "tOR", "tAND", "tRSHIFT", "tLSHIFT", "MULTIPLICATION", "tMOD", "tDIVIDE",
  "tMULTIPLY", "tNOT", "tROOT4", "tROOT3", "tROOT", "tFUNCTION",
  "tVARIABLE", "tNSUPNUM", "tSUPNUM", "tSUBNUM", "BOOLEAN_OPERATOR",
  "PERCENTAGE", "UNARY_MINUS", "'^'", "'!'", "'|'", "tIN", "'='", "'('",
  "')'", "'['", "']'", "'{'", "'}'", "'%'", "$accept", "statement", "unit",
  "exp", "variable", "term", YY_NULL
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,    94,    33,   124,   288,    61,    40,    41,
      91,    93,   123,   125,    37
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    45,    46,    46,    46,    46,    46,    47,    47,    48,
      48,    48,    48,    48,    48,    48,    48,    48,    48,    48,
      48,    48,    48,    48,    48,    48,    48,    48,    48,    48,
      48,    48,    48,    48,    48,    48,    48,    48,    48,    49,
      49,    49,    49,    49,    49,    49,    49,    49,    50,    50,
      50
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     2,     3,     4,     3,     1,     2,     3,
       4,     3,     3,     3,     3,     3,     3,     2,     2,     2,
       1,     2,     2,     2,     3,     3,     3,     4,     4,     3,
       3,     2,     2,     3,     3,     3,     1,     3,     3,     1,
       2,     3,     3,     3,     3,     2,     2,     2,     1,     2,
       2
};

/* YYDEFACT[STATE-NAME] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       0,    36,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    48,     0,     0,     0,     0,     0,     0,     0,     2,
      20,    39,    48,     0,    21,    36,    48,     0,     0,    22,
      23,    32,    47,    46,    45,     0,     0,    40,    49,     0,
       0,     0,     0,     0,     0,     1,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    18,    17,     0,
      19,     3,     0,    31,    48,    50,     0,    49,    12,    11,
      42,    41,    43,     4,    44,    15,     9,    13,    14,     7,
       6,    30,    29,    35,    34,    33,    38,    37,    25,    24,
      26,    16,     0,    49,     5,     8,    28,    27,    10
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int8 yydefgoto[] =
{
      -1,    17,    18,    72,    20,    21
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -20
static const yytype_int16 yypact[] =
{
     116,    80,   143,   143,   143,     9,   143,   143,   143,   143,
      89,    46,   -11,   143,   143,   143,   143,    24,    -7,   253,
     -20,    13,    -5,     6,   -20,   519,    -3,    57,   226,   -12,
     -20,   190,   190,   190,   190,   143,   143,   190,   168,   143,
     143,   286,   313,   346,   379,   -20,    17,   143,   143,   143,
     143,   143,   143,   143,   143,   143,   143,   -20,   -20,   143,
     -20,   -20,   143,   -20,     7,    13,    17,   191,   -20,   -20,
     190,   190,   190,   448,   190,   -20,   -20,   -20,   -20,    19,
     -20,   475,   502,   -12,   -12,   -12,     0,     0,   190,   190,
     190,   -12,   415,   -20,   -20,   -20,   -20,   -20,   -20
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int8 yypgoto[] =
{
     -20,   -20,    -1,     1,     5,   -19
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -9
static const yytype_int8 yytable[] =
{
      23,    19,    65,    27,    28,    29,    24,    31,    32,    33,
      34,    37,    30,    40,    41,    42,    43,    44,    54,    55,
      56,    59,    60,    38,    45,    67,    62,    57,    58,    46,
      24,    -7,    63,    59,    60,    93,    70,    71,    62,    64,
      73,    74,    66,    79,    63,    80,    65,    95,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,     0,     0,
      91,    68,     0,    92,     0,    94,    47,    48,     0,    49,
      50,    51,    52,    53,    38,    54,    55,    56,     0,     0,
       0,     0,    -7,    39,    57,    58,     0,     0,     0,     0,
      59,    60,    25,     0,     2,    62,     3,     0,     4,     5,
       0,    63,     7,     8,     9,    10,    22,     0,     0,    12,
       6,     7,     8,     9,    10,    26,    35,    36,    12,     1,
       0,     2,     0,     3,    13,     4,     5,    14,     0,    15,
       0,    16,     0,     0,     0,     0,     0,     6,     7,     8,
       9,    10,    11,     0,     0,    12,    25,     0,     2,     0,
       3,    13,     4,     5,    14,     0,    15,     0,    16,     0,
       0,     0,     0,     0,     6,     7,     8,     9,    10,    26,
       0,    25,    12,     2,     0,     3,     0,     0,    13,     0,
       0,    14,     0,    15,     0,    16,     0,     0,     0,     6,
       7,     8,     9,    10,    25,     0,     2,    12,     3,     0,
       0,     0,     0,    13,    -8,     0,    14,     0,    15,     0,
      16,     0,     6,     7,     8,     9,    10,    57,    58,     0,
      12,     0,     0,    59,    60,     0,    13,     0,    62,    14,
       0,    15,    69,    16,    63,    47,    48,     0,    49,    50,
      51,    52,    53,     0,    54,    55,    56,     0,     0,     0,
       0,     0,     0,    57,    58,     0,     0,     0,     0,    59,
      60,     0,    47,    48,    62,    49,    50,    51,    52,    53,
      63,    54,    55,    56,     0,     0,     0,     0,     0,     0,
      57,    58,     0,     0,     0,     0,    59,    60,     0,     0,
      61,    62,     0,     0,     0,    47,    48,    63,    49,    50,
      51,    52,    53,     0,    54,    55,    56,     0,     0,     0,
       0,     0,     0,    57,    58,     0,     0,     0,     0,    59,
      60,    75,    47,    48,    62,    49,    50,    51,    52,    53,
      63,    54,    55,    56,     0,     0,     0,     0,     0,     0,
      57,    58,     0,     0,     0,     0,    59,    60,     0,     0,
       0,    62,    76,     0,     0,    47,    48,    63,    49,    50,
      51,    52,    53,     0,    54,    55,    56,     0,     0,     0,
       0,     0,     0,    57,    58,     0,     0,     0,     0,    59,
      60,     0,     0,     0,    62,     0,     0,    77,    47,    48,
      63,    49,    50,    51,    52,    53,     0,    54,    55,    56,
       0,     0,     0,     0,     0,     0,    57,    58,     0,     0,
       0,     0,    59,    60,     0,     0,     0,    62,     0,     0,
       0,     0,    78,    63,    47,    48,     0,    49,    50,    51,
      52,    53,     0,    54,    55,    56,     0,     0,     0,     0,
       0,     0,    57,    58,     0,     0,     0,     0,    59,    60,
       0,     0,     0,    62,    98,     0,     0,    47,    48,    63,
      49,    50,    51,    52,    53,     0,    54,    55,    56,     0,
       0,     0,     0,     0,     0,    57,    58,     0,     0,     0,
       0,    59,    60,     0,     0,     0,    62,    49,    50,    51,
      52,    53,    63,    54,    55,    56,     0,     0,     0,     0,
       0,     0,    57,    58,     0,     0,     0,     0,    59,    60,
       0,     0,     0,    62,    49,    50,    51,    52,    53,    96,
      54,    55,    56,     0,     0,     0,     0,     0,     0,    57,
      58,     0,     0,     0,     0,    59,    60,     0,     0,     0,
      62,     7,     8,     9,    10,    26,    97,     0,    12
};

#define yypact_value_is_default(yystate) \
  ((yystate) == (-20))

#define yytable_value_is_error(yytable_value) \
  YYID (0)

static const yytype_int8 yycheck[] =
{
       1,     0,    21,     2,     3,     4,     1,     6,     7,     8,
       9,    10,     3,    24,    13,    14,    15,    16,    18,    19,
      20,    33,    34,    28,     0,    28,    38,    27,    28,    36,
      25,    36,    44,    33,    34,    28,    35,    36,    38,    26,
      39,    40,    36,    26,    44,    46,    65,    28,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    -1,    -1,
      59,     4,    -1,    62,    -1,    66,     9,    10,    -1,    12,
      13,    14,    15,    16,    28,    18,    19,    20,    -1,    -1,
      -1,    -1,    36,    37,    27,    28,    -1,    -1,    -1,    -1,
      33,    34,     3,    -1,     5,    38,     7,    -1,     9,    10,
      -1,    44,    22,    23,    24,    25,    26,    -1,    -1,    29,
      21,    22,    23,    24,    25,    26,    27,    28,    29,     3,
      -1,     5,    -1,     7,    35,     9,    10,    38,    -1,    40,
      -1,    42,    -1,    -1,    -1,    -1,    -1,    21,    22,    23,
      24,    25,    26,    -1,    -1,    29,     3,    -1,     5,    -1,
       7,    35,     9,    10,    38,    -1,    40,    -1,    42,    -1,
      -1,    -1,    -1,    -1,    21,    22,    23,    24,    25,    26,
      -1,     3,    29,     5,    -1,     7,    -1,    -1,    35,    -1,
      -1,    38,    -1,    40,    -1,    42,    -1,    -1,    -1,    21,
      22,    23,    24,    25,     3,    -1,     5,    29,     7,    -1,
      -1,    -1,    -1,    35,    36,    -1,    38,    -1,    40,    -1,
      42,    -1,    21,    22,    23,    24,    25,    27,    28,    -1,
      29,    -1,    -1,    33,    34,    -1,    35,    -1,    38,    38,
      -1,    40,     6,    42,    44,     9,    10,    -1,    12,    13,
      14,    15,    16,    -1,    18,    19,    20,    -1,    -1,    -1,
      -1,    -1,    -1,    27,    28,    -1,    -1,    -1,    -1,    33,
      34,    -1,     9,    10,    38,    12,    13,    14,    15,    16,
      44,    18,    19,    20,    -1,    -1,    -1,    -1,    -1,    -1,
      27,    28,    -1,    -1,    -1,    -1,    33,    34,    -1,    -1,
      37,    38,    -1,    -1,    -1,     9,    10,    44,    12,    13,
      14,    15,    16,    -1,    18,    19,    20,    -1,    -1,    -1,
      -1,    -1,    -1,    27,    28,    -1,    -1,    -1,    -1,    33,
      34,    35,     9,    10,    38,    12,    13,    14,    15,    16,
      44,    18,    19,    20,    -1,    -1,    -1,    -1,    -1,    -1,
      27,    28,    -1,    -1,    -1,    -1,    33,    34,    -1,    -1,
      -1,    38,    39,    -1,    -1,     9,    10,    44,    12,    13,
      14,    15,    16,    -1,    18,    19,    20,    -1,    -1,    -1,
      -1,    -1,    -1,    27,    28,    -1,    -1,    -1,    -1,    33,
      34,    -1,    -1,    -1,    38,    -1,    -1,    41,     9,    10,
      44,    12,    13,    14,    15,    16,    -1,    18,    19,    20,
      -1,    -1,    -1,    -1,    -1,    -1,    27,    28,    -1,    -1,
      -1,    -1,    33,    34,    -1,    -1,    -1,    38,    -1,    -1,
      -1,    -1,    43,    44,     9,    10,    -1,    12,    13,    14,
      15,    16,    -1,    18,    19,    20,    -1,    -1,    -1,    -1,
      -1,    -1,    27,    28,    -1,    -1,    -1,    -1,    33,    34,
      -1,    -1,    -1,    38,    39,    -1,    -1,     9,    10,    44,
      12,    13,    14,    15,    16,    -1,    18,    19,    20,    -1,
      -1,    -1,    -1,    -1,    -1,    27,    28,    -1,    -1,    -1,
      -1,    33,    34,    -1,    -1,    -1,    38,    12,    13,    14,
      15,    16,    44,    18,    19,    20,    -1,    -1,    -1,    -1,
      -1,    -1,    27,    28,    -1,    -1,    -1,    -1,    33,    34,
      -1,    -1,    -1,    38,    12,    13,    14,    15,    16,    44,
      18,    19,    20,    -1,    -1,    -1,    -1,    -1,    -1,    27,
      28,    -1,    -1,    -1,    -1,    33,    34,    -1,    -1,    -1,
      38,    22,    23,    24,    25,    26,    44,    -1,    29
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,     3,     5,     7,     9,    10,    21,    22,    23,    24,
      25,    26,    29,    35,    38,    40,    42,    46,    47,    48,
      49,    50,    26,    47,    49,     3,    26,    48,    48,    48,
       3,    48,    48,    48,    48,    27,    28,    48,    28,    37,
      24,    48,    48,    48,    48,     0,    36,     9,    10,    12,
      13,    14,    15,    16,    18,    19,    20,    27,    28,    33,
      34,    37,    38,    44,    26,    50,    36,    28,     4,     6,
      48,    48,    48,    48,    48,    35,    39,    41,    43,    26,
      47,    48,    48,    48,    48,    48,    48,    48,    48,    48,
      48,    48,    48,    28,    47,    28,    44,    44,    39
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  However,
   YYFAIL appears to be in use.  Nevertheless, it is formally deprecated
   in Bison 2.4.2's NEWS entry, where a plan to phase it out is
   discussed.  */

#define YYFAIL		goto yyerrlab
#if defined YYFAIL
  /* This is here to suppress warnings from the GCC cpp's
     -Wunused-macros.  Normally we don't worry about that warning, but
     some users do, and we want to make it easy for users to remove
     YYFAIL uses, which will produce warnings from Bison 2.5.  */
#endif

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (&yylloc, yyscanner, YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256

/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)                                \
    do                                                                  \
      if (YYID (N))                                                     \
        {                                                               \
          (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;        \
          (Current).first_column = YYRHSLOC (Rhs, 1).first_column;      \
          (Current).last_line    = YYRHSLOC (Rhs, N).last_line;         \
          (Current).last_column  = YYRHSLOC (Rhs, N).last_column;       \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).first_line   = (Current).last_line   =              \
            YYRHSLOC (Rhs, 0).last_line;                                \
          (Current).first_column = (Current).last_column =              \
            YYRHSLOC (Rhs, 0).last_column;                              \
        }                                                               \
    while (YYID (0))
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K])



/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
	      (Loc).first_line, (Loc).first_column,	\
	      (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (&yylval, &yylloc, YYLEX_PARAM)
#else
# define YYLEX yylex (&yylval, &yylloc, yyscanner)
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value, Location, yyscanner); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp, yyscan_t yyscanner)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep, yylocationp, yyscanner)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
    YYLTYPE const * const yylocationp;
    yyscan_t yyscanner;
#endif
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
  YYUSE (yylocationp);
  YYUSE (yyscanner);
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp, yyscan_t yyscanner)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep, yylocationp, yyscanner)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
    YYLTYPE const * const yylocationp;
    yyscan_t yyscanner;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  YY_LOCATION_PRINT (yyoutput, *yylocationp);
  YYFPRINTF (yyoutput, ": ");
  yy_symbol_value_print (yyoutput, yytype, yyvaluep, yylocationp, yyscanner);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, YYLTYPE *yylsp, int yyrule, yyscan_t yyscanner)
#else
static void
yy_reduce_print (yyvsp, yylsp, yyrule, yyscanner)
    YYSTYPE *yyvsp;
    YYLTYPE *yylsp;
    int yyrule;
    yyscan_t yyscanner;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       , &(yylsp[(yyi + 1) - (yynrhs)])		       , yyscanner);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, yylsp, Rule, yyscanner); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULL, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  YYSIZE_T yysize1;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULL;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - Assume YYFAIL is not used.  It's too flawed to consider.  See
       <http://lists.gnu.org/archive/html/bison-patches/2009-12/msg00024.html>
       for details.  YYERROR is fine as it does not invoke this
       function.
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                yysize1 = yysize + yytnamerr (YY_NULL, yytname[yyx]);
                if (! (yysize <= yysize1
                       && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                  return 2;
                yysize = yysize1;
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  yysize1 = yysize + yystrlen (yyformat);
  if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
    return 2;
  yysize = yysize1;

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, YYLTYPE *yylocationp, yyscan_t yyscanner)
#else
static void
yydestruct (yymsg, yytype, yyvaluep, yylocationp, yyscanner)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
    YYLTYPE *yylocationp;
    yyscan_t yyscanner;
#endif
{
  YYUSE (yyvaluep);
  YYUSE (yylocationp);
  YYUSE (yyscanner);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}




/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (yyscan_t yyscanner)
#else
int
yyparse (yyscanner)
    yyscan_t yyscanner;
#endif
#endif
{
/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Location data for the lookahead symbol.  */
YYLTYPE yylloc;

    /* Number of syntax errors so far.  */
    int yynerrs;

    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.
       `yyls': related to locations.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    /* The location stack.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls;
    YYLTYPE *yylsp;

    /* The locations where the error started and ended.  */
    YYLTYPE yyerror_range[3];

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yytoken = 0;
  yyss = yyssa;
  yyvs = yyvsa;
  yyls = yylsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */
  yyssp = yyss;
  yyvsp = yyvs;
  yylsp = yyls;

#if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
  /* Initialize the default location before parsing starts.  */
  yylloc.first_line   = yylloc.last_line   = 1;
  yylloc.first_column = yylloc.last_column = 1;
#endif
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;
	YYLTYPE *yyls1 = yyls;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yyls1, yysize * sizeof (*yylsp),
		    &yystacksize);

	yyls = yyls1;
	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
	YYSTACK_RELOCATE (yyls_alloc, yyls);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;
  *++yylsp = yylloc;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location.  */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
/* Line 1787 of yacc.c  */
#line 204 "./mp-equation-parser.y"
    { set_result(yyscanner, &(yyvsp[(1) - (1)].int_t)); }
    break;

  case 3:
/* Line 1787 of yacc.c  */
#line 205 "./mp-equation-parser.y"
    { set_result(yyscanner, &(yyvsp[(1) - (2)].int_t)); }
    break;

  case 4:
/* Line 1787 of yacc.c  */
#line 206 "./mp-equation-parser.y"
    {set_variable(yyscanner, (yyvsp[(1) - (3)].name), &(yyvsp[(3) - (3)].int_t)); set_result(yyscanner, &(yyvsp[(3) - (3)].int_t)); }
    break;

  case 5:
/* Line 1787 of yacc.c  */
#line 207 "./mp-equation-parser.y"
    { MPNumber t; do_conversion(yyscanner, &(yyvsp[(1) - (4)].int_t), (yyvsp[(2) - (4)].name), (yyvsp[(4) - (4)].name), &t); set_result(yyscanner, &t); free((yyvsp[(2) - (4)].name)); free((yyvsp[(4) - (4)].name)); }
    break;

  case 6:
/* Line 1787 of yacc.c  */
#line 208 "./mp-equation-parser.y"
    { MPNumber x, t; mp_set_from_integer(1, &x); do_conversion(yyscanner, &x, (yyvsp[(1) - (3)].name), (yyvsp[(3) - (3)].name), &t); set_result(yyscanner, &t); free((yyvsp[(1) - (3)].name)); free((yyvsp[(3) - (3)].name)); }
    break;

  case 7:
/* Line 1787 of yacc.c  */
#line 212 "./mp-equation-parser.y"
    {(yyval.name) = (yyvsp[(1) - (1)].name);}
    break;

  case 8:
/* Line 1787 of yacc.c  */
#line 213 "./mp-equation-parser.y"
    {(yyval.name) = make_unit((yyvsp[(1) - (2)].name), (yyvsp[(2) - (2)].integer)); free((yyvsp[(1) - (2)].name));}
    break;

  case 9:
/* Line 1787 of yacc.c  */
#line 218 "./mp-equation-parser.y"
    {mp_set_from_mp(&(yyvsp[(2) - (3)].int_t), &(yyval.int_t));}
    break;

  case 10:
/* Line 1787 of yacc.c  */
#line 219 "./mp-equation-parser.y"
    {mp_multiply(&(yyvsp[(1) - (4)].int_t), &(yyvsp[(3) - (4)].int_t), &(yyval.int_t));}
    break;

  case 11:
/* Line 1787 of yacc.c  */
#line 220 "./mp-equation-parser.y"
    {mp_floor(&(yyvsp[(2) - (3)].int_t), &(yyval.int_t));}
    break;

  case 12:
/* Line 1787 of yacc.c  */
#line 221 "./mp-equation-parser.y"
    {mp_ceiling(&(yyvsp[(2) - (3)].int_t), &(yyval.int_t));}
    break;

  case 13:
/* Line 1787 of yacc.c  */
#line 222 "./mp-equation-parser.y"
    {mp_round(&(yyvsp[(2) - (3)].int_t), &(yyval.int_t));}
    break;

  case 14:
/* Line 1787 of yacc.c  */
#line 223 "./mp-equation-parser.y"
    {mp_fractional_part(&(yyvsp[(2) - (3)].int_t), &(yyval.int_t));}
    break;

  case 15:
/* Line 1787 of yacc.c  */
#line 224 "./mp-equation-parser.y"
    {mp_abs(&(yyvsp[(2) - (3)].int_t), &(yyval.int_t));}
    break;

  case 16:
/* Line 1787 of yacc.c  */
#line 225 "./mp-equation-parser.y"
    {mp_xpowy(&(yyvsp[(1) - (3)].int_t), &(yyvsp[(3) - (3)].int_t), &(yyval.int_t));}
    break;

  case 17:
/* Line 1787 of yacc.c  */
#line 226 "./mp-equation-parser.y"
    {mp_xpowy_integer(&(yyvsp[(1) - (2)].int_t), (yyvsp[(2) - (2)].integer), &(yyval.int_t));}
    break;

  case 18:
/* Line 1787 of yacc.c  */
#line 227 "./mp-equation-parser.y"
    {mp_xpowy_integer(&(yyvsp[(1) - (2)].int_t), (yyvsp[(2) - (2)].integer), &(yyval.int_t));}
    break;

  case 19:
/* Line 1787 of yacc.c  */
#line 228 "./mp-equation-parser.y"
    {mp_factorial(&(yyvsp[(1) - (2)].int_t), &(yyval.int_t));}
    break;

  case 20:
/* Line 1787 of yacc.c  */
#line 229 "./mp-equation-parser.y"
    {mp_set_from_mp(&(yyvsp[(1) - (1)].int_t), &(yyval.int_t));}
    break;

  case 21:
/* Line 1787 of yacc.c  */
#line 230 "./mp-equation-parser.y"
    {mp_multiply(&(yyvsp[(1) - (2)].int_t), &(yyvsp[(2) - (2)].int_t), &(yyval.int_t));}
    break;

  case 22:
/* Line 1787 of yacc.c  */
#line 231 "./mp-equation-parser.y"
    {mp_invert_sign(&(yyvsp[(2) - (2)].int_t), &(yyval.int_t));}
    break;

  case 23:
/* Line 1787 of yacc.c  */
#line 232 "./mp-equation-parser.y"
    {mp_set_from_mp(&(yyvsp[(2) - (2)].int_t), &(yyval.int_t));}
    break;

  case 24:
/* Line 1787 of yacc.c  */
#line 233 "./mp-equation-parser.y"
    {mp_divide(&(yyvsp[(1) - (3)].int_t), &(yyvsp[(3) - (3)].int_t), &(yyval.int_t));}
    break;

  case 25:
/* Line 1787 of yacc.c  */
#line 234 "./mp-equation-parser.y"
    {mp_modulus_divide(&(yyvsp[(1) - (3)].int_t), &(yyvsp[(3) - (3)].int_t), &(yyval.int_t));}
    break;

  case 26:
/* Line 1787 of yacc.c  */
#line 235 "./mp-equation-parser.y"
    {mp_multiply(&(yyvsp[(1) - (3)].int_t), &(yyvsp[(3) - (3)].int_t), &(yyval.int_t));}
    break;

  case 27:
/* Line 1787 of yacc.c  */
#line 236 "./mp-equation-parser.y"
    {mp_add_integer(&(yyvsp[(3) - (4)].int_t), 100, &(yyvsp[(3) - (4)].int_t)); mp_divide_integer(&(yyvsp[(3) - (4)].int_t), 100, &(yyvsp[(3) - (4)].int_t)); mp_multiply(&(yyvsp[(1) - (4)].int_t), &(yyvsp[(3) - (4)].int_t), &(yyval.int_t));}
    break;

  case 28:
/* Line 1787 of yacc.c  */
#line 237 "./mp-equation-parser.y"
    {mp_add_integer(&(yyvsp[(3) - (4)].int_t), -100, &(yyvsp[(3) - (4)].int_t)); mp_divide_integer(&(yyvsp[(3) - (4)].int_t), -100, &(yyvsp[(3) - (4)].int_t)); mp_multiply(&(yyvsp[(1) - (4)].int_t), &(yyvsp[(3) - (4)].int_t), &(yyval.int_t));}
    break;

  case 29:
/* Line 1787 of yacc.c  */
#line 238 "./mp-equation-parser.y"
    {mp_add(&(yyvsp[(1) - (3)].int_t), &(yyvsp[(3) - (3)].int_t), &(yyval.int_t));}
    break;

  case 30:
/* Line 1787 of yacc.c  */
#line 239 "./mp-equation-parser.y"
    {mp_subtract(&(yyvsp[(1) - (3)].int_t), &(yyvsp[(3) - (3)].int_t), &(yyval.int_t));}
    break;

  case 31:
/* Line 1787 of yacc.c  */
#line 240 "./mp-equation-parser.y"
    {mp_divide_integer(&(yyvsp[(1) - (2)].int_t), 100, &(yyval.int_t));}
    break;

  case 32:
/* Line 1787 of yacc.c  */
#line 241 "./mp-equation-parser.y"
    {do_not(yyscanner, &(yyvsp[(2) - (2)].int_t), &(yyval.int_t));}
    break;

  case 33:
/* Line 1787 of yacc.c  */
#line 242 "./mp-equation-parser.y"
    {mp_and(&(yyvsp[(1) - (3)].int_t), &(yyvsp[(3) - (3)].int_t), &(yyval.int_t));}
    break;

  case 34:
/* Line 1787 of yacc.c  */
#line 243 "./mp-equation-parser.y"
    {mp_or(&(yyvsp[(1) - (3)].int_t), &(yyvsp[(3) - (3)].int_t), &(yyval.int_t));}
    break;

  case 35:
/* Line 1787 of yacc.c  */
#line 244 "./mp-equation-parser.y"
    {mp_xor(&(yyvsp[(1) - (3)].int_t), &(yyvsp[(3) - (3)].int_t), &(yyval.int_t));}
    break;

  case 36:
/* Line 1787 of yacc.c  */
#line 245 "./mp-equation-parser.y"
    {mp_set_from_mp(&(yyvsp[(1) - (1)].int_t), &(yyval.int_t));}
    break;

  case 37:
/* Line 1787 of yacc.c  */
#line 246 "./mp-equation-parser.y"
    {mp_shift(&(yyvsp[(1) - (3)].int_t), mp_cast_to_int(&(yyvsp[(3) - (3)].int_t)), &(yyval.int_t));}
    break;

  case 38:
/* Line 1787 of yacc.c  */
#line 247 "./mp-equation-parser.y"
    {mp_shift(&(yyvsp[(1) - (3)].int_t), -mp_cast_to_int(&(yyvsp[(3) - (3)].int_t)), &(yyval.int_t));}
    break;

  case 39:
/* Line 1787 of yacc.c  */
#line 252 "./mp-equation-parser.y"
    {mp_set_from_mp(&(yyvsp[(1) - (1)].int_t), &(yyval.int_t));}
    break;

  case 40:
/* Line 1787 of yacc.c  */
#line 253 "./mp-equation-parser.y"
    {if (!get_function(yyscanner, (yyvsp[(1) - (2)].name), &(yyvsp[(2) - (2)].int_t), &(yyval.int_t))) YYABORT; free((yyvsp[(1) - (2)].name));}
    break;

  case 41:
/* Line 1787 of yacc.c  */
#line 254 "./mp-equation-parser.y"
    {if (!get_function(yyscanner, (yyvsp[(1) - (3)].name), &(yyvsp[(3) - (3)].int_t), &(yyval.int_t))) YYABORT; mp_xpowy_integer(&(yyval.int_t), (yyvsp[(2) - (3)].integer), &(yyval.int_t)); free((yyvsp[(1) - (3)].name));}
    break;

  case 42:
/* Line 1787 of yacc.c  */
#line 255 "./mp-equation-parser.y"
    {if (!get_inverse_function(yyscanner, (yyvsp[(1) - (3)].name), &(yyvsp[(3) - (3)].int_t), &(yyval.int_t))) YYABORT; mp_xpowy_integer(&(yyval.int_t), -(yyvsp[(2) - (3)].integer), &(yyval.int_t)); free((yyvsp[(1) - (3)].name));}
    break;

  case 43:
/* Line 1787 of yacc.c  */
#line 256 "./mp-equation-parser.y"
    {set_error(yyscanner, PARSER_ERR_UNKNOWN_FUNCTION, (yyvsp[(1) - (3)].name)); free((yyvsp[(1) - (3)].name)); YYABORT;}
    break;

  case 44:
/* Line 1787 of yacc.c  */
#line 257 "./mp-equation-parser.y"
    {mp_root(&(yyvsp[(3) - (3)].int_t), (yyvsp[(1) - (3)].integer), &(yyval.int_t));}
    break;

  case 45:
/* Line 1787 of yacc.c  */
#line 258 "./mp-equation-parser.y"
    {mp_sqrt(&(yyvsp[(2) - (2)].int_t), &(yyval.int_t));}
    break;

  case 46:
/* Line 1787 of yacc.c  */
#line 259 "./mp-equation-parser.y"
    {mp_root(&(yyvsp[(2) - (2)].int_t), 3, &(yyval.int_t));}
    break;

  case 47:
/* Line 1787 of yacc.c  */
#line 260 "./mp-equation-parser.y"
    {mp_root(&(yyvsp[(2) - (2)].int_t), 4, &(yyval.int_t));}
    break;

  case 48:
/* Line 1787 of yacc.c  */
#line 264 "./mp-equation-parser.y"
    {if (!get_variable(yyscanner, (yyvsp[(1) - (1)].name), 1, &(yyval.int_t))) YYABORT; free((yyvsp[(1) - (1)].name));}
    break;

  case 49:
/* Line 1787 of yacc.c  */
#line 265 "./mp-equation-parser.y"
    {if (!get_variable(yyscanner, (yyvsp[(1) - (2)].name), (yyvsp[(2) - (2)].integer), &(yyval.int_t))) YYABORT; free((yyvsp[(1) - (2)].name));}
    break;

  case 50:
/* Line 1787 of yacc.c  */
#line 266 "./mp-equation-parser.y"
    {mp_multiply(&(yyvsp[(1) - (2)].int_t), &(yyvsp[(2) - (2)].int_t), &(yyval.int_t));}
    break;


/* Line 1787 of yacc.c  */
#line 2127 "mp-equation-parser.c"
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (&yylloc, yyscanner, YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (&yylloc, yyscanner, yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }

  yyerror_range[1] = yylloc;

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval, &yylloc, yyscanner);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  yyerror_range[1] = yylsp[1-yylen];
  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;

      yyerror_range[1] = *yylsp;
      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp, yylsp, yyscanner);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  *++yyvsp = yylval;

  yyerror_range[2] = yylloc;
  /* Using YYLLOC is tempting, but would change the location of
     the lookahead.  YYLOC is available though.  */
  YYLLOC_DEFAULT (yyloc, yyerror_range, 2);
  *++yylsp = yyloc;

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (&yylloc, yyscanner, YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, &yylloc, yyscanner);
    }
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp, yylsp, yyscanner);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}


/* Line 2048 of yacc.c  */
#line 269 "./mp-equation-parser.y"


